"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const thenable_1 = require("./thenable");
const maybe_1 = require("./maybe");
const result_1 = require("./result");
describe("Thenable", () => {
    describe("is", () => {
        const isTrue = (obj) => chai_1.expect(obj).to.be.true;
        it("Promise", () => {
            isTrue(thenable_1.isThenable(Promise.resolve()));
        });
        it("Just", () => {
            isTrue(thenable_1.isThenable(maybe_1.Just("")));
        });
        it("None", () => {
            isTrue(thenable_1.isThenable(maybe_1.None()));
        });
        it("Success", () => {
            isTrue(thenable_1.isThenable(result_1.Success("")));
        });
        it("Failure", () => {
            isTrue(thenable_1.isThenable(result_1.Failure("")));
        });
        it("any.then()", () => {
            isTrue(thenable_1.isThenable({ then: () => { } }));
        });
    });
    describe("isn't", () => {
        const isFalse = (obj) => chai_1.expect(obj).to.be.false;
        it("object", () => {
            isFalse(thenable_1.isThenable({}));
        });
        it("number", () => {
            isFalse(thenable_1.isThenable(10));
        });
        it("boolean", () => {
            isFalse(thenable_1.isThenable(true));
        });
        it("string", () => {
            isFalse(thenable_1.isThenable("true"));
        });
        it("any.then === {}", () => {
            isFalse(thenable_1.isThenable({ then: {} }));
        });
    });
});
//# sourceMappingURL=thenable.spec.js.map