"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const monad_1 = require("./monad");
const thenErrorMsg = "Maybe.then() is should be full filled by monad decorator.";
exports.isMaybe = (obj) => exports.isNone(obj) || exports.isJust(obj);
exports.isNone = (obj) => obj instanceof CNone;
exports.isJust = (obj) => obj instanceof CJust;
exports.Just = (value) => new CJust(value);
exports.None = () => new CNone();
exports.Maybe = (value) => value !== null && value !== undefined
    ?
        exports.Just(value)
    :
        exports.None();
class CJust extends monad_1.CJustSuccess {
    then(onJust, onNone) {
        throw new Error(thenErrorMsg);
    }
    isNone() {
        return false;
    }
    isJust() {
        return true;
    }
}
__decorate([
    monad_1.fulfilled(exports.isMaybe),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function, Function]),
    __metadata("design:returntype", Object)
], CJust.prototype, "then", null);
class CNone extends monad_1.CNoneFailure {
    constructor() {
        super(undefined);
    }
    then(onJust, onNone) {
        throw new Error(thenErrorMsg);
    }
    isNone() {
        return true;
    }
    isJust() {
        return false;
    }
    getOrThrow() {
        throw "The value is None";
    }
}
__decorate([
    monad_1.rejected(exports.isMaybe),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function, Function]),
    __metadata("design:returntype", Object)
], CNone.prototype, "then", null);
//# sourceMappingURL=maybe.js.map