"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const monad_1 = require("./monad");
const thenErrorMsg = "Result.then() is should be full filled by monad decorator.";
exports.Success = (value) => new CSuccess(value);
exports.Failure = (error) => new CFailure(error);
exports.Result = (action) => {
    try {
        const result = action();
        if (exports.isResult(result)) {
            return result;
        }
        else {
            return exports.Success(result);
        }
    }
    catch (e) {
        return exports.Failure(e);
    }
};
exports.isResult = (obj) => exports.isSuccess(obj) || exports.isFailure(obj);
exports.isFailure = (obj) => obj instanceof CFailure;
exports.isSuccess = (obj) => obj instanceof CSuccess;
class CSuccess extends monad_1.CJustSuccess {
    then(onSuccess, onFailure) {
        throw new Error(thenErrorMsg);
    }
    isFailure() {
        return false;
    }
    isSuccess() {
        return true;
    }
}
__decorate([
    monad_1.fulfilled(exports.isResult),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function, Function]),
    __metadata("design:returntype", Object)
], CSuccess.prototype, "then", null);
class CFailure extends monad_1.CNoneFailure {
    then(onSuccess, onFailure) {
        throw new Error(thenErrorMsg);
    }
    isFailure() {
        return true;
    }
    isSuccess() {
        return false;
    }
}
__decorate([
    monad_1.rejected(exports.isResult),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function, Function]),
    __metadata("design:returntype", Object)
], CFailure.prototype, "then", null);
//# sourceMappingURL=result.js.map